module SnowmanIO
  module API
    class Friendship < Grape::API
      before(&:authenticate!)

      namespace :users do
        desc "Follow user"
        post ":id/follow" do
          authenticate!
          if user = User.where(id: params[:id]).first
            current_user.follow!(user)
            current_user.touch
            user.touch
            { users: [current_user, user] }
          else
            status 400
            { status: "failed" }
          end
        end

        desc "Unfollow user"
        post ":id/unfollow" do
          authenticate!
          if user = User.where(id: params[:id]).first
            current_user.unfollow!(user)
            current_user.touch
            user.touch
            { users: [current_user, user] }
          else
            status 400
            { status: "failed" }
          end
        end
      end
    end
  end
end
