module SnowmanIO
  module API
    class Info < Grape::API
      get "info0" do
        {
          unpacked: SnowmanIO.unpacked?
        }
      end

      get "info" do
        authenticate!
        {
          base_url: Setting.get(SnowmanIO::BASE_URL_KEY),
          version: SnowmanIO::VERSION,
          force_ssl: Setting.force_ssl?,
          production: (ENV["DEV_MODE"].to_i != 1)
        }
      end

      params do
        requires :force_ssl, type: Boolean
      end
      post "force_ssl" do
        authenticate!
        Setting.set_force_ssl(permitted_params[:force_ssl])
        {force_ssl: Setting.force_ssl?}
      end
    end
  end
end
