module SnowmanIO
  module API
    class Profile < Grape::API
      before(&:authenticate!)

      namespace :users do
        params do
          requires :name, type: String
        end
        post "profile/update_name" do
          authenticate!
          current_user.update_attributes!(name: permitted_params[:name])
          { user: current_user }
        end

        params do
          requires :email, type: String
        end
        post "profile/update_email" do
          authenticate!
          new_email = permitted_params[:email]
          if User.ne(id: current_user.id).where(email: new_email).empty?
            current_user.update_attributes!(email: new_email)
            { user: current_user }
          else
            status 400
            { message: "Duplicate email" }
          end
        end

        params do
          requires :password, type: String
        end
        post "profile/update_password" do
          authenticate!
          current_user.update_attributes!(password: permitted_params[:password])
          { user: current_user }
        end
      end
    end
  end
end
