module SnowmanIO
  class Launcher
    include Celluloid

    def initialize(options)
      @options = options
    end

    def start
      Migration.new.migrate
      app = Rack::Cascade.new [API::Root, Web]
      @web_server = WebServer.supervise_as(:web_server, app, @options.slice(:port, :host, :verbose))
      @main = Loop::Main.supervise_as(:main)
      @checks = Loop::Checks.supervise_as(:checks)
      @spiders = Loop::Spiders.supervise_as(:checks)
    end

    def stop
      @spiders.terminate
      @checks.terminate
      @main.terminate
      @web_server.terminate # TODO: shutdown blocking?
    end
  end
end
