module SnowmanIO
  class Setting
    include Mongoid::Document

    field :name, type: String
    field :value

    def self.set(key, value)
      Setting.find_or_create_by!(name: key).update_attributes!(value: value)
    end

    def self.get(key)
      Setting.where(name: key).first.try(:value)
    end

    def self.force_ssl?
      !!Setting.get(SnowmanIO::FORCE_SSL_KEY)
    end

    def self.set_force_ssl(value)
      Setting.set(SnowmanIO::FORCE_SSL_KEY, value)
    end
  end
end
